"use strict";

var use_nodejs = false;
var uncatchWarn = false;

if (typeof exports !== 'undefined' && this.exports !== exports)
{
	// nodejs config
	use_nodejs = true;
}

function errorobject(errordata)
{

	// object check
	if ((errordata == null) || (typeof errordata != 'object'))
	{
		throw errorobject({message:"wrong type", code:1, additional: typeof errordata});
	}

	if ((errordata.message == null) || (typeof (errordata.message) != 'string'))
	{
		throw errorobject({message:"wrong messagetype", code:2, additional: typeof (errordata.message)});
	}

	if ((errordata.code == null) || (typeof (errordata.code) != 'number'))
	{
		throw errorobject({message:"wrong codetype", code:2, additional: typeof (errordata.code)});
	}

	var whichname = function() {

		if (errordata.which != null)
		{
			if (errordata.which.name != null)
			{
				if (errordata.which.name == "")
				{
					return "(anonym)";
				}
				return errordata.which.name + "()";
			}
		}
		else
		{
			return "(anonym)";
		}

	}();

	// create errorobject
	var errorretobj = {

		// set error message
		message: errordata.message,

		// error code
		code: errordata.code,

		// caller or null
		which: errordata.which,

		// errorspecific data
		additional: errordata.additional,

		// true (additional != null) or false (additional = null)
		hasAdditional: function() {
			if (errordata.additional == null)
			{
				return false;
			}
			return true;
		}(),

		// stringify
		toString: function() {
			return "{message='" + this.message + "', code=" + this.code + ", which='" + whichname + "', hasAdditional=" + this.hasAdditional + "}";
		}

	};

	return errorretobj;

}

// node export
if (use_nodejs)
{
	module.exports = 
	{
		errorobject: errorobject
	};
}
else
{
	if (uncatchWarn)
	{
		// error catch
		window.onerror = function (msg, url, line, col, error) {
    		console.warn("{errorhandler}: '" + msg + "' from " + url + ":" + line + " col: " + col);
    		if (error.hasAdditional())
    		{
    			console.warn(error.additional());
    		}
    		return true;
		};
	}
}